ExtractIcon(MenuName, MenuItemName) 
{
    ; Allocate memory for a SHFILEINFOW struct.
    VarSetCapacity(fileinfo, fisize := A_PtrSize + 688)

    ; Check if the file is a shortcut (.lnk)
    If (InStr(A_LoopFileName, ".lnk"))
	{
        IconPath := GetShortcutTarget(A_LoopFileFullPath)
        
		; If the ShortcutTarget is blank
		If (IconPath = "") {

			; Use the extraction method for non-shortcut files (A_LoopFileFullPath)
			if DllCall("shell32\SHGetFileInfoW", "wstr", A_LoopFileFullPath
			, "uint", 0, "ptr", &fileinfo, "uint", fisize, "uint", 0x100 | 0x000000001)
			{
            hicon := NumGet(fileinfo, 0, "ptr")
            Menu %MenuName%, Icon, %MenuItemName%, HICON:%hicon%
			}
		}
				
    else
		{
		; If the ShortCut isn't blank, use IconPath which is extracted by the WScript
		if DllCall("shell32\SHGetFileInfoW", "wstr", IconPath
        , "uint", 0, "ptr", &fileinfo, "uint", fisize, "uint", 0x100 | 0x000000001)
				{
                hicon := NumGet(fileinfo, 0, "ptr")
                Menu %MenuName%, Icon, %MenuItemName%, HICON:%hicon%
				}
		}
    }
	
	else
	{
		; If the file isn't a shortcut, use extraction method for non-shortcut files (A_LoopFileFullPath)
		if DllCall("shell32\SHGetFileInfoW", "wstr", A_LoopFileFullPath
		, "uint", 0, "ptr", &fileinfo, "uint", fisize, "uint", 0x100 | 0x000000001)
				{
				hicon := NumGet(fileinfo, 0, "ptr")
				Menu %MenuName%, Icon, %MenuItemName%, HICON:%hicon%
				}
    }

}

; Extract the original icon from the LNK ShortcutTarget with WScript
GetShortcutTarget(ShortcutPath)
	{
    obj := ComObjCreate("WScript.Shell").CreateShortcut(ShortcutPath)
    TargetPath := obj.TargetPath
    obj := ""
    Return TargetPath
	}
